# Navidrome la musique dans le cloud

![tag](docker)

J'ai une grande collection de musique en mp3 issue de CD (oui je suis de la vieille école).

Ma musique est présente sous un répertoire de la forme

```
Musique
    |_ Auteur 1
	    |_ Album 1
	    |_ Album 2
	    |_ ...
    |_ Auteur 2
	    |_ ...
    |_ Jazz
	    |_ Auteur 3
	        |_ ... 
```

L'installation de navidrome est assez simple et ce fait via docker

```
    music:
        image: deluan/navidrome:latest
        volumes:
            - /root/docker/data/webdav/music:/music
            - /root/docker/data/navidrome:/data
        environment:
            - ND_SCANSCHEDULE=1h
            - ND_LOGLEVEL=info
            - ND_SESSIONTIMEOUT=24h
		ports:
            - "4533:4533"
        restart: always
```

On voit qu'il demande le dossier music mais aussi un dossier pour enregistrer ces données.

Navidrome est autonome et n'utilise pas de base de donnée.

Il permet l'écoute de nos musqiues via une interface web (port 4533) ou via des client sonic (comme Sublime Music ou Subtracks pour android)

Le principale soucis pour moi est que navidrome classe la musique via les tags et nom via le nom des repertoires.

Pour éviter cela j'utilise un programme qui va renommer les tags de mes fichiers mp3 suivant les répertoires

```
#!/bin/bash
dosomething () {
  echo "Doing something with $1  $2 $3 $4 $5"
  eyeD3 -G "${5//_/ }" -b "${4//_/ }" -a "${4//_/ }" -A "${3//_/ }" -t "${2//_/ }" "$1"
}
find /root/docker/data/webdav/music -name '*.mp3' | grep -v Podcast |while read file; do dosomething "$file" "$(basename "$file")" "$(basename "$(dirname "$file")")" "$(basename "$(dirname "$(dirname "$file")")")" "$(basename "$(dirname "$(dirname "$(dirname "$file")")")")"; done
```

Ce programme utilise eyeD3.

Parfois certains fichiers ne sont pas reconnus comme des fichiers mp3 par eyeD3 dans ce cas j'utile VLC outil/info metadonnée pour modifier les tags

Pour les podcast j'ai en faite créer les répertoires suivants

```
Musique
    |_ Podcast
	    |_ Podcast
	        |_ Emission1
	        |_ Emission2
```

et j'ai fait un programme qui télécharge les n dernieres emissions d'un podcast

```
#!/bin/bash
updatePod () {
    echo $1 $2 $3
    cd $1
    rm *.mp3
    COUNTER=1
    for podcast in $(curl -s $2 | awk '/enclosure/{system("echo "$2);}' FS=\" | sed $3q)
    do
        wget -nc $podcast -O $COUNTER.mp3
        ALBUM=$(basename "$(dirname "$1/$COUNTER.mp3")")
        eyeD3 -G "Podcast" -b "Podcast" -a "Podcast" -A "${ALBUM//_/ }" -n $COUNTER $COUNTER.mp3
        let COUNTER++
    done
}

updatePod /root/docker/data/webdav/music/Podcast/Podcast/Affaires_Sensibles https://radiofrance-podcast.net/podcast09/rss_13940.xml 10;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Blockbusters https://radiofrance-podcast.net/podcast09/rss_17309.xml 10;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Culture_2000 https://culture-2000.lepodcast.fr/rss 5;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/En_quete_de_politique https://radiofrance-podcast.net/podcast09/rss_23497.xml 10;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Entrez_dans_l_histoire https://feeds.audiomeans.fr/feed/971b31f2-42d6-4d41-95ee-1c0554528483.xml 5;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/La_science_CQFD https://radiofrance-podcast.net/podcast09/rss_14312.xml 15;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Le_code_a_change https://radiofrance-podcast.net/podcast09/rss_20856.xml 5;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Le_rendez_vous_tech https://feedpress.me/rdvtech 10;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Relife https://anchor.fm/s/3052f0f0/podcast/rss 5;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Rendez_vous_avec_x https://radiofrance-podcast.net/podcast09/rss_14726.xml 10;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Secret_d_info https://radiofrance-podcast.net/podcast09/rss_13944.xml 5;
updatePod /root/docker/data/webdav/music/Podcast/Podcast/Tech_cafe https://feeds.audiomeans.fr/feed/d6ddb849-3100-43b2-91a5-93f54fe4c4b5.xml 10;

```

comme Navidrome est compatible subsonic on peut interroger les apis de navidrome pour notamment récupérer des images

Exemple de programme qui permet de télécharger cover.jpg dans chaque répertoire de musique

```
import os
from pprint import pprint
import libsonic
from difflib import SequenceMatcher

def similar(list, search):
    idx = 0
    find = None
    for elt in list:
        val = SequenceMatcher(None, elt, search).ratio()
        if val > idx and val > 0.5:
            idx = val
            find = elt
    return idx, find

def downloadCover(conn, cover, path):
    jpg = conn.getCoverArt(cover)
    with open(path, 'wb') as file:
        file.write(jpg.read())
    print("download %s" % path)

print('list cover start')
conn = libsonic.Connection('https://music.fraoustin.fr' , 'myuser' , 'mypassword' , port=443)
albums = [album for album in conn.getAlbumList(ltype='newest', size='500')['albumList']['album']]
covers = {}
for album in albums:
    album = conn.getAlbum(album['id'])
    cover = album['album']['coverArt']
    path = os.path.dirname(album['album']['song'][0]['path'])
    covers[path] = cover

print('list cover ok')

print('found cover start')
for dir  in [elt[0] for elt in os.walk('.') if len([f for f in os.listdir(elt[0]) if os.path.isfile(os.path.join('.', elt[0], f))]) > 0]:
    dirsearch = dir
    for subpath in ['.\Jazz', '.\Classique', '.\Opera']:
        if dir.startswith(subpath):
            dirsearch = '.\\' + dir[len(subpath)+1:]
    idx, coverid = similar(covers.keys(), dirsearch)
    if coverid is not None:
        pathcover = os.path.join(dir,'cover.jpg')
        downloadCover(conn, covers[coverid], pathcover)

print('found cover ok')
```